// ************************************************************************ //
// The types declared in this file were generated from data read from the
// WSDL File described below:
// WSDL     : http://wsf.cdyne.com/WeatherWS/Weather.asmx?WSDL
//  >Import : http://wsf.cdyne.com/WeatherWS/Weather.asmx?WSDL>0
// Encoding : utf-8
// Version  : 1.0
// (2012-06-28 22:56:53 - - $Rev: 37707 $)
// ************************************************************************ //

unit Weather;

interface

uses InvokeRegistry, SOAPHTTPClient, Types, XSBuiltIns;

const
  IS_OPTN = $0001;
  IS_UNBD = $0002;
  IS_NLBL = $0004;
  IS_REF  = $0080;


type

  // ************************************************************************ //
  // The following types, referred to in the WSDL document are not being represented
  // in this file. They are either aliases[@] of other types represented or were referred
  // to but never[!] declared in the document. The types from the latter category
  // typically map to predefined/known XML or Embarcadero types; however, they could also 
  // indicate incorrect WSDL documents that failed to declare or import a schema type.
  // ************************************************************************ //
  // !:string          - "http://www.w3.org/2001/XMLSchema"[Gbl]
  // !:short           - "http://www.w3.org/2001/XMLSchema"[Gbl]
  // !:dateTime        - "http://www.w3.org/2001/XMLSchema"[Gbl]
  // !:boolean         - "http://www.w3.org/2001/XMLSchema"[Gbl]

  POP                  = class;                 { "http://ws.cdyne.com/WeatherWS/"[GblCplx] }
  WeatherDescription   = class;                 { "http://ws.cdyne.com/WeatherWS/"[GblCplx] }
  temp                 = class;                 { "http://ws.cdyne.com/WeatherWS/"[GblCplx] }
  Forecast             = class;                 { "http://ws.cdyne.com/WeatherWS/"[GblCplx] }
  WeatherReturn2       = class;                 { "http://ws.cdyne.com/WeatherWS/"[GblCplx] }
  WeatherReturn        = class;                 { "http://ws.cdyne.com/WeatherWS/"[GblElm] }
  ForecastReturn2      = class;                 { "http://ws.cdyne.com/WeatherWS/"[GblCplx] }
  ForecastReturn       = class;                 { "http://ws.cdyne.com/WeatherWS/"[GblElm] }



  // ************************************************************************ //
  // XML       : POP, global, <complexType>
  // Namespace : http://ws.cdyne.com/WeatherWS/
  // ************************************************************************ //
  POP = class(TRemotable)
  private
    FNighttime: string;
    FNighttime_Specified: boolean;
    FDaytime: string;
    FDaytime_Specified: boolean;
    procedure SetNighttime(Index: Integer; const Astring: string);
    function  Nighttime_Specified(Index: Integer): boolean;
    procedure SetDaytime(Index: Integer; const Astring: string);
    function  Daytime_Specified(Index: Integer): boolean;
  published
    property Nighttime: string  Index (IS_OPTN) read FNighttime write SetNighttime stored Nighttime_Specified;
    property Daytime:   string  Index (IS_OPTN) read FDaytime write SetDaytime stored Daytime_Specified;
  end;

  ArrayOfWeatherDescription2 = array of WeatherDescription;   { "http://ws.cdyne.com/WeatherWS/"[GblCplx] }
  ArrayOfWeatherDescription =  type ArrayOfWeatherDescription2;      { "http://ws.cdyne.com/WeatherWS/"[GblElm] }


  // ************************************************************************ //
  // XML       : WeatherDescription, global, <complexType>
  // Namespace : http://ws.cdyne.com/WeatherWS/
  // ************************************************************************ //
  WeatherDescription = class(TRemotable)
  private
    FWeatherID: SmallInt;
    FDescription: string;
    FDescription_Specified: boolean;
    FPictureURL: string;
    FPictureURL_Specified: boolean;
    procedure SetDescription(Index: Integer; const Astring: string);
    function  Description_Specified(Index: Integer): boolean;
    procedure SetPictureURL(Index: Integer; const Astring: string);
    function  PictureURL_Specified(Index: Integer): boolean;
  published
    property WeatherID:   SmallInt  read FWeatherID write FWeatherID;
    property Description: string    Index (IS_OPTN) read FDescription write SetDescription stored Description_Specified;
    property PictureURL:  string    Index (IS_OPTN) read FPictureURL write SetPictureURL stored PictureURL_Specified;
  end;



  // ************************************************************************ //
  // XML       : temp, global, <complexType>
  // Namespace : http://ws.cdyne.com/WeatherWS/
  // ************************************************************************ //
  temp = class(TRemotable)
  private
    FMorningLow: string;
    FMorningLow_Specified: boolean;
    FDaytimeHigh: string;
    FDaytimeHigh_Specified: boolean;
    procedure SetMorningLow(Index: Integer; const Astring: string);
    function  MorningLow_Specified(Index: Integer): boolean;
    procedure SetDaytimeHigh(Index: Integer; const Astring: string);
    function  DaytimeHigh_Specified(Index: Integer): boolean;
  published
    property MorningLow:  string  Index (IS_OPTN) read FMorningLow write SetMorningLow stored MorningLow_Specified;
    property DaytimeHigh: string  Index (IS_OPTN) read FDaytimeHigh write SetDaytimeHigh stored DaytimeHigh_Specified;
  end;



  // ************************************************************************ //
  // XML       : Forecast, global, <complexType>
  // Namespace : http://ws.cdyne.com/WeatherWS/
  // ************************************************************************ //
  Forecast = class(TRemotable)
  private
    FDate: TXSDateTime;
    FWeatherID: SmallInt;
    FDesciption: string;
    FDesciption_Specified: boolean;
    FTemperatures: temp;
    FProbabilityOfPrecipiation: POP;
    procedure SetDesciption(Index: Integer; const Astring: string);
    function  Desciption_Specified(Index: Integer): boolean;
  public
    destructor Destroy; override;
  published
    property Date:                      TXSDateTime  read FDate write FDate;
    property WeatherID:                 SmallInt     read FWeatherID write FWeatherID;
    property Desciption:                string       Index (IS_OPTN) read FDesciption write SetDesciption stored Desciption_Specified;
    property Temperatures:              temp         read FTemperatures write FTemperatures;
    property ProbabilityOfPrecipiation: POP          read FProbabilityOfPrecipiation write FProbabilityOfPrecipiation;
  end;



  // ************************************************************************ //
  // XML       : WeatherReturn, global, <complexType>
  // Namespace : http://ws.cdyne.com/WeatherWS/
  // ************************************************************************ //
  WeatherReturn2 = class(TRemotable)
  private
    FSuccess: Boolean;
    FResponseText: string;
    FResponseText_Specified: boolean;
    FState: string;
    FState_Specified: boolean;
    FCity: string;
    FCity_Specified: boolean;
    FWeatherStationCity: string;
    FWeatherStationCity_Specified: boolean;
    FWeatherID: SmallInt;
    FDescription: string;
    FDescription_Specified: boolean;
    FTemperature: string;
    FTemperature_Specified: boolean;
    FRelativeHumidity: string;
    FRelativeHumidity_Specified: boolean;
    FWind: string;
    FWind_Specified: boolean;
    FPressure: string;
    FPressure_Specified: boolean;
    FVisibility: string;
    FVisibility_Specified: boolean;
    FWindChill: string;
    FWindChill_Specified: boolean;
    FRemarks: string;
    FRemarks_Specified: boolean;
    procedure SetResponseText(Index: Integer; const Astring: string);
    function  ResponseText_Specified(Index: Integer): boolean;
    procedure SetState(Index: Integer; const Astring: string);
    function  State_Specified(Index: Integer): boolean;
    procedure SetCity(Index: Integer; const Astring: string);
    function  City_Specified(Index: Integer): boolean;
    procedure SetWeatherStationCity(Index: Integer; const Astring: string);
    function  WeatherStationCity_Specified(Index: Integer): boolean;
    procedure SetDescription(Index: Integer; const Astring: string);
    function  Description_Specified(Index: Integer): boolean;
    procedure SetTemperature(Index: Integer; const Astring: string);
    function  Temperature_Specified(Index: Integer): boolean;
    procedure SetRelativeHumidity(Index: Integer; const Astring: string);
    function  RelativeHumidity_Specified(Index: Integer): boolean;
    procedure SetWind(Index: Integer; const Astring: string);
    function  Wind_Specified(Index: Integer): boolean;
    procedure SetPressure(Index: Integer; const Astring: string);
    function  Pressure_Specified(Index: Integer): boolean;
    procedure SetVisibility(Index: Integer; const Astring: string);
    function  Visibility_Specified(Index: Integer): boolean;
    procedure SetWindChill(Index: Integer; const Astring: string);
    function  WindChill_Specified(Index: Integer): boolean;
    procedure SetRemarks(Index: Integer; const Astring: string);
    function  Remarks_Specified(Index: Integer): boolean;
  published
    property Success:            Boolean   read FSuccess write FSuccess;
    property ResponseText:       string    Index (IS_OPTN) read FResponseText write SetResponseText stored ResponseText_Specified;
    property State:              string    Index (IS_OPTN) read FState write SetState stored State_Specified;
    property City:               string    Index (IS_OPTN) read FCity write SetCity stored City_Specified;
    property WeatherStationCity: string    Index (IS_OPTN) read FWeatherStationCity write SetWeatherStationCity stored WeatherStationCity_Specified;
    property WeatherID:          SmallInt  read FWeatherID write FWeatherID;
    property Description:        string    Index (IS_OPTN) read FDescription write SetDescription stored Description_Specified;
    property Temperature:        string    Index (IS_OPTN) read FTemperature write SetTemperature stored Temperature_Specified;
    property RelativeHumidity:   string    Index (IS_OPTN) read FRelativeHumidity write SetRelativeHumidity stored RelativeHumidity_Specified;
    property Wind:               string    Index (IS_OPTN) read FWind write SetWind stored Wind_Specified;
    property Pressure:           string    Index (IS_OPTN) read FPressure write SetPressure stored Pressure_Specified;
    property Visibility:         string    Index (IS_OPTN) read FVisibility write SetVisibility stored Visibility_Specified;
    property WindChill:          string    Index (IS_OPTN) read FWindChill write SetWindChill stored WindChill_Specified;
    property Remarks:            string    Index (IS_OPTN) read FRemarks write SetRemarks stored Remarks_Specified;
  end;



  // ************************************************************************ //
  // XML       : WeatherReturn, global, <element>
  // Namespace : http://ws.cdyne.com/WeatherWS/
  // ************************************************************************ //
  WeatherReturn = class(WeatherReturn2)
  private
  published
  end;

  ArrayOfForecast = array of Forecast;          { "http://ws.cdyne.com/WeatherWS/"[GblCplx] }


  // ************************************************************************ //
  // XML       : ForecastReturn, global, <complexType>
  // Namespace : http://ws.cdyne.com/WeatherWS/
  // ************************************************************************ //
  ForecastReturn2 = class(TRemotable)
  private
    FSuccess: Boolean;
    FResponseText: string;
    FResponseText_Specified: boolean;
    FState: string;
    FState_Specified: boolean;
    FCity: string;
    FCity_Specified: boolean;
    FWeatherStationCity: string;
    FWeatherStationCity_Specified: boolean;
    FForecastResult: ArrayOfForecast;
    FForecastResult_Specified: boolean;
    procedure SetResponseText(Index: Integer; const Astring: string);
    function  ResponseText_Specified(Index: Integer): boolean;
    procedure SetState(Index: Integer; const Astring: string);
    function  State_Specified(Index: Integer): boolean;
    procedure SetCity(Index: Integer; const Astring: string);
    function  City_Specified(Index: Integer): boolean;
    procedure SetWeatherStationCity(Index: Integer; const Astring: string);
    function  WeatherStationCity_Specified(Index: Integer): boolean;
    procedure SetForecastResult(Index: Integer; const AArrayOfForecast: ArrayOfForecast);
    function  ForecastResult_Specified(Index: Integer): boolean;
  public
    destructor Destroy; override;
  published
    property Success:            Boolean          read FSuccess write FSuccess;
    property ResponseText:       string           Index (IS_OPTN) read FResponseText write SetResponseText stored ResponseText_Specified;
    property State:              string           Index (IS_OPTN) read FState write SetState stored State_Specified;
    property City:               string           Index (IS_OPTN) read FCity write SetCity stored City_Specified;
    property WeatherStationCity: string           Index (IS_OPTN) read FWeatherStationCity write SetWeatherStationCity stored WeatherStationCity_Specified;
    property ForecastResult:     ArrayOfForecast  Index (IS_OPTN) read FForecastResult write SetForecastResult stored ForecastResult_Specified;
  end;



  // ************************************************************************ //
  // XML       : ForecastReturn, global, <element>
  // Namespace : http://ws.cdyne.com/WeatherWS/
  // ************************************************************************ //
  ForecastReturn = class(ForecastReturn2)
  private
  published
  end;


  // ************************************************************************ //
  // Namespace : http://ws.cdyne.com/WeatherWS/
  // soapAction: http://ws.cdyne.com/WeatherWS/%operationName%
  // transport : http://schemas.xmlsoap.org/soap/http
  // style     : document
  // use       : literal
  // binding   : WeatherSoap12
  // service   : Weather
  // port      : WeatherSoap12
  // URL       : http://wsf.cdyne.com/WeatherWS/Weather.asmx
  // ************************************************************************ //
  WeatherSoap = interface(IInvokable)
  ['{B44226BE-9F29-DEEC-15EF-908FF3FF1AE5}']
    function  GetWeatherInformation: ArrayOfWeatherDescription2; stdcall;
    function  GetCityForecastByZIP(const ZIP: string): ForecastReturn2; stdcall;
    function  GetCityWeatherByZIP(const ZIP: string): WeatherReturn2; stdcall;
  end;


  // ************************************************************************ //
  // Namespace : http://ws.cdyne.com/WeatherWS/
  // style     : ????
  // use       : ????
  // binding   : WeatherHttpGet
  // service   : Weather
  // port      : WeatherHttpGet
  // ************************************************************************ //
  WeatherHttpGet = interface(IInvokable)
  ['{5251CB81-D74E-368A-6A6D-B85377E73D36}']
    function  GetWeatherInformation: ArrayOfWeatherDescription; stdcall;
    function  GetCityForecastByZIP(const ZIP: string): ForecastReturn; stdcall;
    function  GetCityWeatherByZIP(const ZIP: string): WeatherReturn; stdcall;
  end;


  // ************************************************************************ //
  // Namespace : http://ws.cdyne.com/WeatherWS/
  // style     : ????
  // use       : ????
  // binding   : WeatherHttpPost
  // service   : Weather
  // port      : WeatherHttpPost
  // ************************************************************************ //
  WeatherHttpPost = interface(IInvokable)
  ['{92BF0FDB-B457-3308-CB3B-CA11BC439487}']
    function  GetWeatherInformation: ArrayOfWeatherDescription; stdcall;
    function  GetCityForecastByZIP(const ZIP: string): ForecastReturn; stdcall;
    function  GetCityWeatherByZIP(const ZIP: string): WeatherReturn; stdcall;
  end;

function GetWeatherSoap(UseWSDL: Boolean=System.False; Addr: string=''; HTTPRIO: THTTPRIO = nil): WeatherSoap;
function GetWeatherHttpGet(UseWSDL: Boolean=System.False; Addr: string=''; HTTPRIO: THTTPRIO = nil): WeatherHttpGet;
function GetWeatherHttpPost(UseWSDL: Boolean=System.False; Addr: string=''; HTTPRIO: THTTPRIO = nil): WeatherHttpPost;


implementation
  uses SysUtils;

function GetWeatherSoap(UseWSDL: Boolean; Addr: string; HTTPRIO: THTTPRIO): WeatherSoap;
const
  defWSDL = 'http://wsf.cdyne.com/WeatherWS/Weather.asmx?WSDL';
  defURL  = 'http://wsf.cdyne.com/WeatherWS/Weather.asmx';
  defSvc  = 'Weather';
  defPrt  = 'WeatherSoap12';
var
  RIO: THTTPRIO;
begin
  Result := nil;
  if (Addr = '') then
  begin
    if UseWSDL then
      Addr := defWSDL
    else
      Addr := defURL;
  end;
  if HTTPRIO = nil then
    RIO := THTTPRIO.Create(nil)
  else
    RIO := HTTPRIO;
  try
    Result := (RIO as WeatherSoap);
    if UseWSDL then
    begin
      RIO.WSDLLocation := Addr;
      RIO.Service := defSvc;
      RIO.Port := defPrt;
    end else
      RIO.URL := Addr;
  finally
    if (Result = nil) and (HTTPRIO = nil) then
      RIO.Free;
  end;
end;


function GetWeatherHttpGet(UseWSDL: Boolean; Addr: string; HTTPRIO: THTTPRIO): WeatherHttpGet;
const
  defWSDL = 'http://wsf.cdyne.com/WeatherWS/Weather.asmx?WSDL';
  defURL  = '';
  defSvc  = 'Weather';
  defPrt  = 'WeatherHttpGet';
var
  RIO: THTTPRIO;
begin
  Result := nil;
  if (Addr = '') then
  begin
    if UseWSDL then
      Addr := defWSDL
    else
      Addr := defURL;
  end;
  if HTTPRIO = nil then
    RIO := THTTPRIO.Create(nil)
  else
    RIO := HTTPRIO;
  try
    Result := (RIO as WeatherHttpGet);
    if UseWSDL then
    begin
      RIO.WSDLLocation := Addr;
      RIO.Service := defSvc;
      RIO.Port := defPrt;
    end else
      RIO.URL := Addr;
  finally
    if (Result = nil) and (HTTPRIO = nil) then
      RIO.Free;
  end;
end;


function GetWeatherHttpPost(UseWSDL: Boolean; Addr: string; HTTPRIO: THTTPRIO): WeatherHttpPost;
const
  defWSDL = 'http://wsf.cdyne.com/WeatherWS/Weather.asmx?WSDL';
  defURL  = '';
  defSvc  = 'Weather';
  defPrt  = 'WeatherHttpPost';
var
  RIO: THTTPRIO;
begin
  Result := nil;
  if (Addr = '') then
  begin
    if UseWSDL then
      Addr := defWSDL
    else
      Addr := defURL;
  end;
  if HTTPRIO = nil then
    RIO := THTTPRIO.Create(nil)
  else
    RIO := HTTPRIO;
  try
    Result := (RIO as WeatherHttpPost);
    if UseWSDL then
    begin
      RIO.WSDLLocation := Addr;
      RIO.Service := defSvc;
      RIO.Port := defPrt;
    end else
      RIO.URL := Addr;
  finally
    if (Result = nil) and (HTTPRIO = nil) then
      RIO.Free;
  end;
end;


procedure POP.SetNighttime(Index: Integer; const Astring: string);
begin
  FNighttime := Astring;
  FNighttime_Specified := True;
end;

function POP.Nighttime_Specified(Index: Integer): boolean;
begin
  Result := FNighttime_Specified;
end;

procedure POP.SetDaytime(Index: Integer; const Astring: string);
begin
  FDaytime := Astring;
  FDaytime_Specified := True;
end;

function POP.Daytime_Specified(Index: Integer): boolean;
begin
  Result := FDaytime_Specified;
end;

procedure WeatherDescription.SetDescription(Index: Integer; const Astring: string);
begin
  FDescription := Astring;
  FDescription_Specified := True;
end;

function WeatherDescription.Description_Specified(Index: Integer): boolean;
begin
  Result := FDescription_Specified;
end;

procedure WeatherDescription.SetPictureURL(Index: Integer; const Astring: string);
begin
  FPictureURL := Astring;
  FPictureURL_Specified := True;
end;

function WeatherDescription.PictureURL_Specified(Index: Integer): boolean;
begin
  Result := FPictureURL_Specified;
end;

procedure temp.SetMorningLow(Index: Integer; const Astring: string);
begin
  FMorningLow := Astring;
  FMorningLow_Specified := True;
end;

function temp.MorningLow_Specified(Index: Integer): boolean;
begin
  Result := FMorningLow_Specified;
end;

procedure temp.SetDaytimeHigh(Index: Integer; const Astring: string);
begin
  FDaytimeHigh := Astring;
  FDaytimeHigh_Specified := True;
end;

function temp.DaytimeHigh_Specified(Index: Integer): boolean;
begin
  Result := FDaytimeHigh_Specified;
end;

destructor Forecast.Destroy;
begin
  SysUtils.FreeAndNil(FDate);
  SysUtils.FreeAndNil(FTemperatures);
  SysUtils.FreeAndNil(FProbabilityOfPrecipiation);
  inherited Destroy;
end;

procedure Forecast.SetDesciption(Index: Integer; const Astring: string);
begin
  FDesciption := Astring;
  FDesciption_Specified := True;
end;

function Forecast.Desciption_Specified(Index: Integer): boolean;
begin
  Result := FDesciption_Specified;
end;

procedure WeatherReturn2.SetResponseText(Index: Integer; const Astring: string);
begin
  FResponseText := Astring;
  FResponseText_Specified := True;
end;

function WeatherReturn2.ResponseText_Specified(Index: Integer): boolean;
begin
  Result := FResponseText_Specified;
end;

procedure WeatherReturn2.SetState(Index: Integer; const Astring: string);
begin
  FState := Astring;
  FState_Specified := True;
end;

function WeatherReturn2.State_Specified(Index: Integer): boolean;
begin
  Result := FState_Specified;
end;

procedure WeatherReturn2.SetCity(Index: Integer; const Astring: string);
begin
  FCity := Astring;
  FCity_Specified := True;
end;

function WeatherReturn2.City_Specified(Index: Integer): boolean;
begin
  Result := FCity_Specified;
end;

procedure WeatherReturn2.SetWeatherStationCity(Index: Integer; const Astring: string);
begin
  FWeatherStationCity := Astring;
  FWeatherStationCity_Specified := True;
end;

function WeatherReturn2.WeatherStationCity_Specified(Index: Integer): boolean;
begin
  Result := FWeatherStationCity_Specified;
end;

procedure WeatherReturn2.SetDescription(Index: Integer; const Astring: string);
begin
  FDescription := Astring;
  FDescription_Specified := True;
end;

function WeatherReturn2.Description_Specified(Index: Integer): boolean;
begin
  Result := FDescription_Specified;
end;

procedure WeatherReturn2.SetTemperature(Index: Integer; const Astring: string);
begin
  FTemperature := Astring;
  FTemperature_Specified := True;
end;

function WeatherReturn2.Temperature_Specified(Index: Integer): boolean;
begin
  Result := FTemperature_Specified;
end;

procedure WeatherReturn2.SetRelativeHumidity(Index: Integer; const Astring: string);
begin
  FRelativeHumidity := Astring;
  FRelativeHumidity_Specified := True;
end;

function WeatherReturn2.RelativeHumidity_Specified(Index: Integer): boolean;
begin
  Result := FRelativeHumidity_Specified;
end;

procedure WeatherReturn2.SetWind(Index: Integer; const Astring: string);
begin
  FWind := Astring;
  FWind_Specified := True;
end;

function WeatherReturn2.Wind_Specified(Index: Integer): boolean;
begin
  Result := FWind_Specified;
end;

procedure WeatherReturn2.SetPressure(Index: Integer; const Astring: string);
begin
  FPressure := Astring;
  FPressure_Specified := True;
end;

function WeatherReturn2.Pressure_Specified(Index: Integer): boolean;
begin
  Result := FPressure_Specified;
end;

procedure WeatherReturn2.SetVisibility(Index: Integer; const Astring: string);
begin
  FVisibility := Astring;
  FVisibility_Specified := True;
end;

function WeatherReturn2.Visibility_Specified(Index: Integer): boolean;
begin
  Result := FVisibility_Specified;
end;

procedure WeatherReturn2.SetWindChill(Index: Integer; const Astring: string);
begin
  FWindChill := Astring;
  FWindChill_Specified := True;
end;

function WeatherReturn2.WindChill_Specified(Index: Integer): boolean;
begin
  Result := FWindChill_Specified;
end;

procedure WeatherReturn2.SetRemarks(Index: Integer; const Astring: string);
begin
  FRemarks := Astring;
  FRemarks_Specified := True;
end;

function WeatherReturn2.Remarks_Specified(Index: Integer): boolean;
begin
  Result := FRemarks_Specified;
end;

destructor ForecastReturn2.Destroy;
var
  I: Integer;
begin
  for I := 0 to System.Length(FForecastResult)-1 do
    SysUtils.FreeAndNil(FForecastResult[I]);
  System.SetLength(FForecastResult, 0);
  inherited Destroy;
end;

procedure ForecastReturn2.SetResponseText(Index: Integer; const Astring: string);
begin
  FResponseText := Astring;
  FResponseText_Specified := True;
end;

function ForecastReturn2.ResponseText_Specified(Index: Integer): boolean;
begin
  Result := FResponseText_Specified;
end;

procedure ForecastReturn2.SetState(Index: Integer; const Astring: string);
begin
  FState := Astring;
  FState_Specified := True;
end;

function ForecastReturn2.State_Specified(Index: Integer): boolean;
begin
  Result := FState_Specified;
end;

procedure ForecastReturn2.SetCity(Index: Integer; const Astring: string);
begin
  FCity := Astring;
  FCity_Specified := True;
end;

function ForecastReturn2.City_Specified(Index: Integer): boolean;
begin
  Result := FCity_Specified;
end;

procedure ForecastReturn2.SetWeatherStationCity(Index: Integer; const Astring: string);
begin
  FWeatherStationCity := Astring;
  FWeatherStationCity_Specified := True;
end;

function ForecastReturn2.WeatherStationCity_Specified(Index: Integer): boolean;
begin
  Result := FWeatherStationCity_Specified;
end;

procedure ForecastReturn2.SetForecastResult(Index: Integer; const AArrayOfForecast: ArrayOfForecast);
begin
  FForecastResult := AArrayOfForecast;
  FForecastResult_Specified := True;
end;

function ForecastReturn2.ForecastResult_Specified(Index: Integer): boolean;
begin
  Result := FForecastResult_Specified;
end;

initialization
  { WeatherSoap }
  InvRegistry.RegisterInterface(TypeInfo(WeatherSoap), 'http://ws.cdyne.com/WeatherWS/', 'utf-8');
  InvRegistry.RegisterDefaultSOAPAction(TypeInfo(WeatherSoap), 'http://ws.cdyne.com/WeatherWS/%operationName%');
  InvRegistry.RegisterInvokeOptions(TypeInfo(WeatherSoap), ioDocument);
  InvRegistry.RegisterInvokeOptions(TypeInfo(WeatherSoap), ioSOAP12);
  { WeatherSoap.GetWeatherInformation }
  InvRegistry.RegisterMethodInfo(TypeInfo(WeatherSoap), 'GetWeatherInformation', '',
                                 '[ReturnName="GetWeatherInformationResult"]', IS_OPTN);
  InvRegistry.RegisterParamInfo(TypeInfo(WeatherSoap), 'GetWeatherInformation', 'GetWeatherInformationResult', '',
                                '[ArrayItemName="WeatherDescription"]');
  { WeatherSoap.GetCityForecastByZIP }
  InvRegistry.RegisterMethodInfo(TypeInfo(WeatherSoap), 'GetCityForecastByZIP', '',
                                 '[ReturnName="GetCityForecastByZIPResult"]', IS_OPTN);
  { WeatherSoap.GetCityWeatherByZIP }
  InvRegistry.RegisterMethodInfo(TypeInfo(WeatherSoap), 'GetCityWeatherByZIP', '',
                                 '[ReturnName="GetCityWeatherByZIPResult"]');
  { WeatherHttpGet }
  InvRegistry.RegisterInterface(TypeInfo(WeatherHttpGet), 'http://ws.cdyne.com/WeatherWS/', 'utf-8');
  InvRegistry.RegisterDefaultSOAPAction(TypeInfo(WeatherHttpGet), '');
  { WeatherHttpPost }
  InvRegistry.RegisterInterface(TypeInfo(WeatherHttpPost), 'http://ws.cdyne.com/WeatherWS/', 'utf-8');
  InvRegistry.RegisterDefaultSOAPAction(TypeInfo(WeatherHttpPost), '');
  RemClassRegistry.RegisterXSClass(POP, 'http://ws.cdyne.com/WeatherWS/', 'POP');
  RemClassRegistry.RegisterXSInfo(TypeInfo(ArrayOfWeatherDescription2), 'http://ws.cdyne.com/WeatherWS/', 'ArrayOfWeatherDescription2', 'ArrayOfWeatherDescription');
  RemClassRegistry.RegisterXSInfo(TypeInfo(ArrayOfWeatherDescription), 'http://ws.cdyne.com/WeatherWS/', 'ArrayOfWeatherDescription');
  RemClassRegistry.RegisterXSClass(WeatherDescription, 'http://ws.cdyne.com/WeatherWS/', 'WeatherDescription');
  RemClassRegistry.RegisterXSClass(temp, 'http://ws.cdyne.com/WeatherWS/', 'temp');
  RemClassRegistry.RegisterXSClass(Forecast, 'http://ws.cdyne.com/WeatherWS/', 'Forecast');
  RemClassRegistry.RegisterXSClass(WeatherReturn2, 'http://ws.cdyne.com/WeatherWS/', 'WeatherReturn2', 'WeatherReturn');
  RemClassRegistry.RegisterXSClass(WeatherReturn, 'http://ws.cdyne.com/WeatherWS/', 'WeatherReturn');
  RemClassRegistry.RegisterXSInfo(TypeInfo(ArrayOfForecast), 'http://ws.cdyne.com/WeatherWS/', 'ArrayOfForecast');
  RemClassRegistry.RegisterXSClass(ForecastReturn2, 'http://ws.cdyne.com/WeatherWS/', 'ForecastReturn2', 'ForecastReturn');
  RemClassRegistry.RegisterExternalPropName(TypeInfo(ForecastReturn2), 'ForecastResult', '[ArrayItemName="Forecast"]');
  RemClassRegistry.RegisterXSClass(ForecastReturn, 'http://ws.cdyne.com/WeatherWS/', 'ForecastReturn');

end.